Bug 135515 - HPT 372A hangs at boot
HPT 372A hangs at boot
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
i686 Linux
medium Severity high
: ---
: ---
Assigned To: Alan Cox
Brian Brock
Depends On:
  Show dependency treegraph
Reported: 2004-10-13 04:39 EDT by Charles Lopes
Modified: 2007-11-30 17:10 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2006-05-04 08:55:16 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Patchlet to revert in order to fix problem (12.70 KB, patch)
2004-10-13 04:42 EDT, Charles Lopes
no flags Details | Diff
dmesg from booting (10.08 KB, text/plain)
2004-11-10 05:44 EST, Charles Lopes
no flags Details
Patch used to boot 2.6.9-1.681_FC3 (907 bytes, patch)
2004-12-07 10:15 EST, Charles Lopes
no flags Details | Diff
Patch to fall back when dpll setup fails (3.05 KB, patch)
2005-07-18 09:25 EDT, Charles Lopes
no flags Details | Diff

  None (edit)
Description Charles Lopes 2004-10-13 04:39:19 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; rv:1.7.3) Gecko/20041008

Description of problem:
The system hangs while detecting/setting up a disk drive on the
HPT372A IDE controler at boot up time. The problem doesn't show if no
IDE device is attached to that controler. Also the problem doesn't
occur with kernel-2.6.5-1.358.
I narrowed down the problem to a recent patch by Alan Cox (see
attached patch). Reverting the patch and recompiling the kernel fixes
the problem.
I have reproduced the problem with FC1 where the patch was already
present. That could explain bugs #104817 and #110720

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1. Install FC2 on machine with HPT372A
2. Update to the most recent kernel errata (2.6.8-1.521)
3. Reboot and watch system hang

Additional info:
Comment 1 Charles Lopes 2004-10-13 04:42:08 EDT
Created attachment 105124 [details]
Patchlet to revert in order to fix problem
Comment 2 Alan Cox 2004-10-30 09:34:18 EDT
Please supply the boot log so I can take a look at it
Comment 3 Alan Cox 2004-10-31 09:10:15 EST
PS: if you are building new kernels if you can build one that prints
the RID/DID that would be useful so I can check if we are misdetecting
one of the HPT372 variants that isnt -N
Comment 4 Charles Lopes 2004-11-10 05:44:07 EST
Created attachment 106405 [details]
dmesg from booting

here's the boot log I get when I boot without any IDE device attached
to the controller. I added a printk to display RID and DID.
Comment 5 Charles Lopes 2004-11-10 06:03:18 EST
If I attach a disk drive, the kernel crashes right after displaying
the following lines (I'm copying this from reading the screen):

HPT372A: chipset revision 2
did=5 rid=2
hpt: HPT372N detected, using 372N timing.
FREQ: 96 PLL: 41
HPT372A: 100% native mode on irq 11
hpt: no known IDE timings, disabling DMA.
hpt: no known IDE timings, disabling DMA.
hde: HDS724040KLAT80, ATA DISK drive
Unable to handle kernel NULL pointer dereference at virtual address
 printing eip:

I used kernel 2.6.9-1.667 for i686 here. The call trace is:

Comment 6 Charles Lopes 2004-12-07 10:11:13 EST
I had another go at tracking down this problem. The problem occurs in
"pci_bus_clock_list" in "hpt366.c" because "chipset_table" is NULL.
The reason for this originates in "init_hpt37x". For some reason the
card I've got falls through the PLL adjustement without calling
"pci_set_drvdata". I tried to have the code fallback to 33Mhz PCI
clock (somehow as I don't understand most of the code) and I got my
system to boot again with a such patched 2.6.9-1.681_FC3 kernel. Is
there anything else I could try to help find a real solution to this
Comment 7 Charles Lopes 2004-12-07 10:15:29 EST
Created attachment 108044 [details]
Patch used to boot 2.6.9-1.681_FC3
Comment 8 Alan Cox 2004-12-07 10:29:51 EST
The PLL tuning code has several flaws in it. I've been rewriting it
but while it now tunes the PLL I broke something else. Its on my todo
list after the more urgent stuff.
Comment 9 Charles Lopes 2004-12-07 10:44:42 EST
Is it possible to have access to this new broken code and/or any type
of documentation? I have a few machines waiting to be installed and am
willing to spend some time on this. Also, would you like to have one
of the cards I'm using shipped to you?
Comment 10 Dave Jones 2005-04-16 01:17:48 EDT
Fedora Core 2 has now reached end of life, and no further updates will be
provided by Red Hat.  The Fedora legacy project will be producing further kernel
updates for security problems only.

If this bug has not been fixed in the latest Fedora Core 2 update kernel, please
try to reproduce it under Fedora Core 3, and reopen if necessary, changing the
product version accordingly.

Thank you.
Comment 11 Charles Lopes 2005-04-19 06:27:13 EDT
The bug is still there with the latest kernel from FC3 updates (2.6.11-1.14_FC3)
and FC4 test1. If you can't fix it quickly, it would be nice if at least the
crash was removed by disabling that IDE controller under the incriminating
Comment 12 Alan Cox 2005-05-19 12:51:54 EDT
The only documentation I'm aware of is NDA although there is a highpoint vendor
driver for 2.4 that is at least as good as any documentation I've seen if not
far better.
Comment 14 Dave Jones 2005-06-27 19:15:32 EDT
Mass update of -test bugs to update version to fc4.
(Please retest on final release, and report results if you have not already done

Comment 15 Dave Jones 2005-07-15 17:06:07 EDT
[This comment has been added as a mass update for all FC4 kernel bugs.
 If you have migrated this bug from an FC3 bug today, ignore this comment.]

Please retest your problem with todays 2.6.12-1.1398_FC4 update.

If your problem involved being unable to boot, or some hardware not being
detected correctly, please make sure your /etc/modprobe.conf is correct *BEFORE*
installing any kernel updates.
If in doubt, you can recreate this file using..

mv /etc/sysconfig/hwconf /etc/sysconfig/hwconf.bak
mv /etc/modprobe.conf /etc/modprobe.conf.bak

Thank you.
Comment 16 Charles Lopes 2005-07-18 09:25:12 EDT
Created attachment 116867 [details]
Patch to fall back when dpll setup fails

This patch will let info->speed to be set for 372N even if we are going to use
the pll setup. This value will only get used if the pll setup fails.
I've been using this patch on a few computers for months with success.
Comment 17 Eric Wort 2005-07-29 18:28:21 EDT
I have a very similar problem with a HPT 374 SATA card that uses this driver,
but the 7/18/05 patch didn't fix my problem.

The kernel hangs with no visible errors after displaying the drives attached to
the card.  If there are no drives attached, it boots normally.
Comment 18 Dave Jones 2005-09-30 02:06:28 EDT
Mass update to all FC4 bugs:

An update has been released (2.6.13-1.1526_FC4) which rebases to a new upstream
kernel ( As there were ~3500 changes upstream between this and the
previous kernel, it's possible your bug has been fixed already.

Please retest with this update, and update this bug if necessary.

Comment 19 Dave Jones 2005-11-10 14:03:30 EST
2.6.14-1.1637_FC4 has been released as an update for FC4.
Please retest with this update, as a large amount of code has been changed in
this release, which may have fixed your problem.

Thank you.
Comment 20 Dave Jones 2006-02-03 01:30:33 EST
This is a mass-update to all currently open kernel bugs.

A new kernel update has been released (Version: 2.6.15-1.1830_FC4)
based upon a new upstream kernel release.

Please retest against this new kernel, as a large number of patches
go into each upstream release, possibly including changes that
may address this problem.

This bug has been placed in NEEDINFO_REPORTER state.
Due to the large volume of inactive bugs in bugzilla, if this bug is
still in this state in two weeks time, it will be closed.

Should this bug still be relevant after this period, the reporter
can reopen the bug at any time. Any other users on the Cc: list
of this bug can request that the bug be reopened by adding a
comment to the bug.

If this bug is a problem preventing you from installing the
release this version is filed against, please see bug 169613.

Thank you.
Comment 21 John Thacker 2006-05-04 08:55:16 EDT
Closing per previous comment.

Note You need to log in before you can comment on or make changes to this bug.